#!/usr/local/bin/perl
################################################################################
#AUTHORS: 	Fleury Serge
#VERSION: 	1.0.1
#email:		serge.fleury@univ-aris3.fr
#url:		http://www.cavi.univ-paris3.fr/ilpga/ilpga/tal/
#date:		Feb/03/2002
#FILE:
#    This file is part of MKCorpus.
#
#################################################################################

use Tk;
use Tk::Dialog;
use Tk::Photo;
use Tk::DialogBox;
use Win32::OLE qw(in with);

$main = MainWindow->new(-title=>'(MS-Word2XML)');
$main->geometry("400x300+100+100");

$imgLogo=$main->Photo(-file=>"logo-mkc.gif");

$lblLogo=$main->Button(-image=>$imgLogo)->place(-y=>0,-x=>0,-width=>400,-height=>300);

$frame1 = $main->Frame()->pack(-side=>'bottom', -pady=>5);

$frameG1 = $frame1->Frame()->pack(-side=>'top', -pady=>5);
$frameD1 = $frame1->Frame()->pack(-side=>'bottom', -pady=>5);

$frameG2 = $frameG1->Frame()->pack(-side=>'left', -pady=>5);
$frameD2 = $frameG1->Frame()->pack(-side=>'right', -pady=>5);

$frameG3 = $frameD1->Frame()->pack(-side=>'left', -pady=>5);
$frameD3 = $frameD1->Frame()->pack(-side=>'right', -pady=>5);

$frame2 = $main->Frame()->pack();
$frame3 = $main->Frame()->pack();

$libelF = $frameG2->Label(-text=>'Chemin du rpertoire (input) :')->pack(-padx=>5);

$defil = $frameD2-> Scrollbar(-orient => "horizontal");
$montantF = $frameD2->Entry(-highlightcolor => "blue", -xscrollcommand => ['set' => $defil] )
    ->pack(		-fill => 'x',
			-expand => 1);
$defil->pack(-fill => 'x',
	     -expand => 1);
$defil->configure(-command => [$montantF => 'xview']);

$libelE = $frameG3->Label(-text=>'Chemin du rpertoire (output) :')->pack(-padx=>5);


$defil2 = $frameD3-> Scrollbar(-orient => "horizontal");

$montantE = $frameD3->Entry(-highlightcolor => "red", -xscrollcommand => ['set' => $defil2] )
    ->pack(		-fill => 'x',
			-expand => 1);
$defil2->pack(-fill => 'x',
	     -expand => 1);
$defil2->configure(-command => [$montantE => 'xview']);

$raz = $main->Button(-text=>'RAZ', -activeforeground=>"blue",-relief=>'flat', -command=>\&vider)->pack(-side=>'left', -padx=>5, -pady=>5);
$calcul = $main->Button(-text=>'Word2Xml', -activeforeground=>"blue",-relief=>'flat', -command=>\&loadword2txt)->pack(-side=>'left', -padx=>5, -pady=>5);
$help = $main->Button(-text=>'Help', -activeforeground=>"blue",-relief=>'flat', -command=>\&help)->pack(-side=>'right', -padx=>5, -pady=>5);
$fin = $main->Button(-text=>'Exit', -activeforeground=>"blue",-relief=>'flat', -command=>sub {exit})->pack(-side=>'right', -padx=>5, -pady=>5);
$calcul2 = $main->Button(-width=>40, -text=>'Word2Xml-Concat',-activeforeground=>"blue",-relief=>'flat',  -command=>\&loadword2txt2)->pack(-side=>'right',  -fill=>'x', -expand =>1);
MainLoop;
 

sub loadword2txt {

    $chemin=$montantF->get();
    print "in: ".$chemin,"\n";
    $cheminout=$montantE->get();
    print "out : ".$cheminout,"\n";
    print "Conversion In-Progress\n";
    if ($chemin ne "") {
	if ($chemin !~ /[\/\\]$/) { $chemin.="/"};
	if (!opendir(DIR, $chemin)) {
	    &mkPrintErreur("ERREUR : can't open $chemin: $!\n");
	    return;
	}
	my @files = readdir(DIR);
	closedir(DIR);
	if ($cheminout eq "") {
		$cheminout = $chemin;
	    }
	else {
	    if (!opendir(DIR2, $cheminout)) {
		&mkPrintErreur("ERREUR : can't open $cheminout: $!\n");
		return;
	    } 
	    if ($cheminout !~ /[\/\\]$/) { $cheminout.="/"};
	}
	my $filecount = 0;
	
	foreach my $file (@files) {
		$filecount++;
		print "CountFile : ".$filecount,"\n";
		next if $file =~ /^\.\.?$/;
		$tmpfile=$file;
		$file = $chemin.$file;
		print "I => ",$file,"\n";
		next if $file !~ /\.doc$/;
		if (-f $file) {
		    my $fileOut = $cheminout."".$tmpfile."-conv2xml.xml";
		    print "Fileout : ".$fileOut,"\n";
		    open(OUT,">$fileOut");
		    print OUT "<?xml version=\"1.0\" encoding=\"ISO-8859-1\" standalone=\"yes\"?>\n";
		    print OUT "<document>\n";
		    print OUT "<fileWordInput>\n<name>$file</name>\n";
		    my ($word) = Win32::OLE->new('Word.Application', 'Quit') ||
			die "Couldn't run Word";
		    my ($doc)  = $word->Documents->Open($file);
		    my($index) = 0;
		    for my $paragraph (in $doc->Paragraphs) {
#			print "Paragraphe number : $index\n";
			$index++;
			# Remove trailing ^M (the paragraph marker) from Range.
			my($text) = substr($paragraph->Range->Text, 0, -1);
			print OUT "<paragraphe number=\"$index\">\n<content>$text</content>\n</paragraphe>\n";
		    }
		    $doc->{Saved} = 1;
		    $doc->Close;
		    print OUT "</fileWordInput>\n</document>\n";
		    close(OUT);
		}
		
	    }
	&mkPrintMsgInfo("Conversion termine dans : $cheminout \n");
    }
    else {
	&mkPrintErreur("ERREUR : impossible d\'accder au rpertoire $chemin\n");
	return;
    }
}


sub loadword2txt2 {

    $chemin=$montantF->get();
    print "in: ".$chemin,"\n";
    $cheminout=$montantE->get();
    print "out : ".$cheminout,"\n";
    print "Conversion In-Progress\n";
    if ($chemin ne "") {
	if ($chemin !~ /[\/\\]$/) { $chemin.="/"};
	if (!opendir(DIR, $chemin)) {
	    &mkPrintErreur("ERREUR : can't open $chemin: $!\n");
	    return;
	}
	my @files = readdir(DIR);
	closedir(DIR);
	if ($cheminout eq "") {
		$cheminout = $chemin;
	    }
	else {
	    if (!opendir(DIR2, $cheminout)) {
		&mkPrintErreur("ERREUR : can't open $cheminout: $!\n");
		return;
	    } 
	    if ($cheminout !~ /[\/\\]$/) { $cheminout.="/"};
	}
	my $filecount = 0;
	my $fileOut = $cheminout."concat_and_conversion2xml.xml";
	print "Fileout : ".$fileOut,"\n";
	open(OUT,">$fileOut");
	print OUT "<?xml version=\"1.0\" encoding=\"ISO-8859-1\" standalone=\"yes\"?>\n";
	print OUT "<document>\n";
	
	foreach my $file (@files) {
		$filecount++;
		print "CountFile : ".$filecount,"\n";
		next if $file =~ /^\.\.?$/;
		$tmpfile=$file;
		$file = $chemin.$file;
		print "I => ",$file,"\n";
		next if $file !~ /\.doc$/;
		if (-f $file) {
		    
		    print OUT "<fileWordInput>\n<name>$file</name>\n";		    
		    my ($word) = Win32::OLE->new('Word.Application', 'Quit') ||
			die "Couldn't run Word";
		    my ($doc)  = $word->Documents->Open($file);
		    my($index) = 0;
		    for my $paragraph (in $doc->Paragraphs) {
			$index++;
			# Remove trailing ^M (the paragraph marker) from Range.
			my($text) = substr($paragraph->Range->Text, 0, -1);
			print OUT "<paragraphe number=\"$index\">\n<content>$text</content>\n</paragraphe>\n";
		    }
		    $doc->{Saved} = 1;
		    $doc->Close;
		    print OUT "</fileWordInput>\n";		    
		   
		}
		
	    }
	 print OUT "</document>\n";
	 close(OUT);
	&mkPrintMsgInfo("Conversion et concatnation termines dans : $fileOut \n");
    }
    else {
	&mkPrintErreur("ERREUR : impossible d\'accder au rpertoire $chemin\n");
	return;
    }
}



sub  mkPrintErreur {
	my $msg = shift;
	$main->Dialog(
		 -title => "ERROR !",
		      -text  => $msg
		 )->Show();
}

sub  mkPrintMsgInfo {
    my $msg = shift;
    $main->Dialog(
		  -title => "Info : ",
		  -text  => $msg
		)->Show();
}

sub vider {
	$montantF->delete(0, 'end');
	$montantE->delete(0, 'end');
}

sub help {

    my $msg ="1. Option Word2Xml : conversion de fichiers Word dans un rpertoire donn au format XML (extension fichier-conv2xml.txt)\n\n2.Option Word2Xml-Concat : conversion de fichiers Word dans un rpertoire donn au format TXT avec concatnation dans un seul fichier (concat_and_conversion2xml.txt)\n";
    $main->Dialog(
		  -title => "Help : ",
		  -text  => $msg
		)->Show();
}
